
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux内核剖析 之 进程地址空间（一） / iVAN</title>

    <meta name="description" content="Linux内核剖析 之 进程地址空间（一） 绪论     内核获取内存方式--直接了当:     1. 从分区页框分配器获取内存(__get_free_pages()或alloc_pages()):     2. 使用slab分配器为专用或通用对象分配内存(kmem_cache_alloc()或kmalloc()):     3. 使用vmalloc或vmalloc_32获取一块非连续内存区.     如果申请的内存得以满足,这些函数返回一个页描述符地址或线性地址.     *内核申请内存使用这些简单方法基于以下两个原因:     1.内">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux内核剖析 之 进程地址空间（一）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>绪论</h1>
<p>    内核获取内存方式——直接了当：</p>
<p>    1. 从分区页框分配器获取内存(__get_free_pages()或alloc_pages())；</p>
<p>    2. 使用slab分配器为专用或通用对象分配内存(kmem_cache_alloc()或kmalloc())；</p>
<p>    3. 使用vmalloc或vmalloc_32获取一块非连续内存区。</p>
<p>    如果申请的内存得以满足，这些函数返回一个页描述符地址或线性地址。</p>
<p>    *内核申请内存使用这些简单方法基于以下两个原因：</p>
<p>    1.内核是操作系统中优先级最高的成分。如果内核申请动态内存，那么必定有正当理由。因此，没有理由推迟处理这个请求。</p>
<p>    2.内核信任自己。所有内核函数都是假定没有错误的，因此内核函数不必插入针对编程错误的任何保护措施。</p>
<p>    *当给用户态进程分配内存时，情况完全不同：</p>
<p>    1.进程对动态内存的请求被认为是不紧迫的。内核总是尽量推迟给用户态进程分配动态内存。</p>
<p>    2.用户进程是不可信任的，因此，内核必须能随时准备捕捉用户进程引起的所有寻址错误。</p>
<p><strong>主要内容：</strong></p>
<p>    *内核如何实现对进程动态内存的推迟分配？</p>
<p>    ——使用一种新的资源（线性地址区）</p>
<p>    当用户进程请求动态内存时，并没有获得请求的页框，而是获得了一个新的线性地址的使用权。这线性地址区域就成为进程地址空间的一部分。</p>
<p>    *为什么要推迟分配？</p>
<p>    *进程怎样看待动态内存。</p>
<p>    *进程地址空间的基本组成。</p>
<p>    *缺页异常处理程序在推迟给进程分配页框中所起的作用。</p>
<p>    *内核怎样创建和删除进程的整个地址空间？</p>
<p>    *与进程的地址空间管理有关的API和系统调用。</p>
<p>====&gt;&gt;&gt;&gt;&gt;</p>
<p>    1. 进程地址空间</p>
<p>    2. 内存描述符</p>
<p>    3. 线性区</p>
<p>    4. 缺页异常处理程序</p>
<p>    5. 创建和删除进程的地址空间</p>
<p>    6. 堆的管理</p>
<h1>进程地址空间</h1>
<p>    进程的地址空间（Address Space）由允许进程使用的全部线性地址组成。一个进程使用的进程地址空间与另一个进程使用的进程地址空间之间没有关系。如果进程之间共享相同的地址空间，则被称为线程。</p>
<p>    内核可以通过增加或删除某些线性地址区间来动态修改进程的地址空间。</p>
<p>    内核通过所谓线性区的资源来表示线性地址空间，线性地址空间由起始线性地址、长度以及相应访问权限来描述。</p>
<p>    起始地址和长度都是4096（一页）的整数倍——提高效率。</p>
<p>    *进程创建新的线性区的典型情况（六种）：</p>
<p>    程序执行</p>
<p>    exec()函数</p>
<p>    缺页异常处理程序</p>
<p>    内存映射</p>
<p>    IPC共享内存</p>
<p>    malloc()函数—heap</p>
<p>    *与创建、删除线性区相关的系统调用：</p>
<table>
<tbody>
<tr>
<td>
<br />系统调用</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />brk()</p>
</td>
<td>
<br />改变进程堆的大小</p>
</td>
</tr>
<tr>
<td>
<br />execve()</p>
</td>
<td>
<br />装入可执行文件，从而改变进程的地址空间</p>
</td>
</tr>
<tr>
<td>
<br />_exit()</p>
</td>
<td>
<br />结束当前进程并撤销它的进程地址空间</p>
</td>
</tr>
<tr>
<td>
<br />fork()</p>
</td>
<td>
<br />创建一个新的进程，并创建新的地址空间。</p>
</td>
</tr>
<tr>
<td>
<br />mmap(),mmap2()</p>
</td>
<td>
<br />为文件创建一个内存映射，从而扩大进程的地址空间</p>
</td>
</tr>
<tr>
<td>
<br />mremap()</p>
</td>
<td>
<br />扩大或缩小线性区</p>
</td>
</tr>
<tr>
<td>
<br />remap_file_pages()</p>
</td>
<td>
<br />为文件创建非线性映射</p>
</td>
</tr>
<tr>
<td>
<br />munmap()</p>
</td>
<td>
<br />撤销对文件的内存映射，从而缩小进程的地址空间</p>
</td>
</tr>
<tr>
<td>
<br />shmat()</p>
</td>
<td>
<br />创建一个共享线性区</p>
</td>
</tr>
<tr>
<td>
<br />shmdt()</p>
</td>
<td>
<br />撤销一个共享线性区</p>
</td>
</tr>
</tbody>
</table>
<p>    确定进程所拥有的线性地址区是内核的任务，这使得缺页处理程序能够有效的处理以下两种无效的线性地址：</p>
<p>    1. 由编程错误引发的非法地址访问（如数组越界、非法指针）；</p>
<p>    2. 由缺页（物理页）引发的无效线性地址，即使这个线性地址属于进程地址空间，但是内核还未分配物理页。——请求调页。</p>
<p> </p>
<h1>内存描述符</h1>
<p>    与进程地址空间的全部信息都包含在一个叫做内存描述符（Memory Descriptor）的数据结构中，这个结构的类型是mm_struct，进程描述符的mm字段指向此结构。</p>
<p>    无论是内核线程还是用户进程，对于内核来说，都是task_struct这个数据结构的一个实例，task_struct被称为进程描述符（process descriptor)，因为它记录了这个进程所有的上下文（context）。其中有一个被称为“内存描述符”（memory descriptor）的数据结构 mm_struct，该结构抽象并描述了Linux视角下管理进程地址空间的所有信息。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MDIxNzA3MzQyNjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZW1oaGIySnllV0Z1ZEE9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>    [start_code,end_code)表示代码段的地址空间范围。 </p>
<p>    [start_data,end_data)表示数据段的地址空间范围。 </p>
<p>    [start_brk,brk)分别表示heap段的起始空间和当前的heap指针。 </p>
<p>    [start_stack,end_stack)表示stack段的地址空间范围。 </p>
<p>    mmap_base表示memory mapping段的起始地址。 </p>
<p>    具体结构图：</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MDIxNzExNDI4NjY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZW1oaGIySnllV0Z1ZEE9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>    内存描述符：</p>
<p>    mm_strcut定义：</p>
<pre>struct mm_struct {
	struct vm_area_struct * mmap;		/* list of VMAs */
	struct rb_root mm_rb;
	struct vm_area_struct * mmap_cache;	/* last find_vma result */
	unsigned long (*get_unmapped_area) (struct file *filp,
				unsigned long addr, unsigned long len,
				unsigned long pgoff, unsigned long flags);
	void (*unmap_area) (struct vm_area_struct *area);
	unsigned long mmap_base;		/* base of mmap area */
	unsigned long free_area_cache;		/* first hole */
	pgd_t * pgd;
	atomic_t mm_users;			/* How many users with user space */
	atomic_t mm_count;			/* How many references to "struct mm_struct" (users count as 1) */
	int map_count;				/* number of VMAs */
	struct rw_semaphore mmap_sem;
	spinlock_t page_table_lock;		/* Protects page tables, mm-&gt;rss, mm-&gt;anon_rss */

	struct list_head mmlist;		/* List of maybe swapped mm's.  These are globally strung
						 * together off init_mm.mmlist, and are protected
						 * by mmlist_lock
						 */
	unsigned long start_code, end_code, start_data, end_data;
	unsigned long start_brk, brk, start_stack;
	unsigned long arg_start, arg_end, env_start, env_end;
	unsigned long rss, anon_rss, total_vm, locked_vm, shared_vm;
	unsigned long exec_vm, stack_vm, reserved_vm, def_flags, nr_ptes;

	unsigned long saved_auxv[42]; /* for /proc/PID/auxv */

	unsigned dumpable:1;
	cpumask_t cpu_vm_mask;

	/* Architecture-specific MM context */
	mm_context_t context;

	/* Token based thrashing protection. */
	unsigned long swap_token_time;
	char recent_pagein;

	/* coredumping support */
	int core_waiters;
	struct completion *core_startup_done, core_done;

	/* aio bits */
	rwlock_t		ioctx_list_lock;
	struct kioctx		*ioctx_list;

	struct kioctx		default_kioctx;

	unsigned long hiwater_rss;	/* High-water RSS usage */
	unsigned long hiwater_vm;	/* High-water virtual memory usage */
};</pre>
<p>   <br />
mm_struct字段：</p>
<table>
<tbody>
<tr>
<td>
<br />类型</p>
</td>
<td>
<br />字段</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />struct vm_area_struct*</p>
</td>
<td>
<br />mmap</p>
</td>
<td>
<br />指向线性区域对象的链表头</p>
</td>
</tr>
<tr>
<td>
<br />struct rb_root</p>
</td>
<td>
<br />mm_rb</p>
</td>
<td>
<br />指向线性区对象的红黑树的根</p>
</td>
</tr>
<tr>
<td>
<br />struct vm_area_struct*</p>
</td>
<td>
<br />mmap_cache</p>
</td>
<td>
<br />指向最后一个引用的线性区对象</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long (*) ()</p>
</td>
<td>
<br />get_unmapped_area</p>
</td>
<td>
<br />在进程地址空间中搜索有效线性地址区</p>
</td>
</tr>
<tr>
<td>
<br />void (*) ()</p>
</td>
<td>
<br />unmap_area</p>
</td>
<td>
<br />释放线性地址区间时调用的方法</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />free_area_cache </p>
</td>
<td>
<br />内核从这个地址开始搜索进程地址空间中线性地址的空闲区域</p>
</td>
</tr>
<tr>
<td>
<br />pgd_t *</p>
</td>
<td>
<br />pdg</p>
</td>
<td>
<br />指向页全局目录</p>
</td>
</tr>
<tr>
<td>
<br />atomic_t</p>
</td>
<td>
<br />mm_users</p>
</td>
<td>
<br />次使用计数器</p>
</td>
</tr>
<tr>
<td>
<br />atomic_t</p>
</td>
<td>
<br />mm_count</p>
</td>
<td>
<br />主使用计数器</p>
</td>
</tr>
<tr>
<td>
<br />int</p>
</td>
<td>
<br />map_count</p>
</td>
<td>
<br />线性区的个数</p>
</td>
</tr>
<tr>
<td>
<br />struct rw_semaphore</p>
</td>
<td>
<br />mmap_sem</p>
</td>
<td>
<br />线性区的读/写信号量</p>
</td>
</tr>
<tr>
<td>
<br />spinlock_t</p>
</td>
<td>
<br />page_table_lock</p>
</td>
<td>
<br />线性区的自旋所和页表的自旋锁</p>
</td>
</tr>
<tr>
<td>
<br />struct list_head</p>
</td>
<td>
<br />mmlist</p>
</td>
<td>
<br />指向内存描述符链表中的相邻元素</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />start_code</p>
</td>
<td>
<br />可执行代码的起始地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />end_code</p>
</td>
<td>
<br />可执行代码的最后地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />start_data</p>
</td>
<td>
<br />已初始化数据的起始地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />end_data</p>
</td>
<td>
<br />已初始化数据的最后地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />start_brk</p>
</td>
<td>
<br />堆的起始地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />brk</p>
</td>
<td>
<br />堆的当前最后地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />start_stack</p>
</td>
<td>
<br />用户堆栈的起始地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />arg_start</p>
</td>
<td>
<br />命令行参数的起始地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />arg_end</p>
</td>
<td>
<br />命令行参数的最后地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />env_start</p>
</td>
<td>
<br />环境变量的起始地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />env_end</p>
</td>
<td>
<br />环境变量的最后地址</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />rss</p>
</td>
<td>
<br />分配给进程的页框数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />anon_rss</p>
</td>
<td>
<br />非配给匿名内存映射的页框数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />total_vm</p>
</td>
<td>
<br />进程地址空间的大小(页数)</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />locked_vm</p>
</td>
<td>
<br />锁住而不能换出的页的个数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />shared_vm</p>
</td>
<td>
<br />共享文件内存映射中的页数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />exec_vm</p>
</td>
<td>
<br />可执行内存映射中的页数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />stack_vm</p>
</td>
<td>
<br />用户堆栈中的页数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />reserved_vm</p>
</td>
<td>
<br />在保留区中的页数或在特殊线性区中的页数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />def_flags</p>
</td>
<td>
<br />线性区默认的访问标志</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />nr_ptes</p>
</td>
<td>
<br />进程的页表数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long []</p>
</td>
<td>
<br />saved_auxv</p>
</td>
<td>
<br />开始执行ELF程序时使用</p>
</td>
</tr>
<tr>
<td>
<br />unsigned int</p>
</td>
<td>
<br />dumpable</p>
</td>
<td>
<br />表示是否可以产生内存转储信息的标志</p>
</td>
</tr>
<tr>
<td>
<br />cpumask_t</p>
</td>
<td>
<br />cpu_vm_mask</p>
</td>
<td>
<br />用于惰性TLB交换的位掩码</p>
</td>
</tr>
<tr>
<td>
<br />mm_context_t</p>
</td>
<td>
<br />context</p>
</td>
<td>
<br />指向有关特定体系结构信息的表</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />swap_token_time</p>
</td>
<td>
<br />进程在这个时间将有资格获得交换标志</p>
</td>
</tr>
<tr>
<td>
<br />char</p>
</td>
<td>
<br />recent_pagein</p>
</td>
<td>
<br />最近发生了主缺页，则设置该标志</p>
</td>
</tr>
<tr>
<td>
<br />int</p>
</td>
<td>
<br />core_waiters</p>
</td>
<td>
<br />正在把进程地址空间的内容转储到core文件中的轻量级进程的数目</p>
</td>
</tr>
<tr>
<td>
<br />struct completion *</p>
</td>
<td>
<br />core_startup_done</p>
</td>
<td>
<br />指向创建内存转储文件的补充原语</p>
</td>
</tr>
<tr>
<td>
<br />struct completion</p>
</td>
<td>
<br />core_done</p>
</td>
<td>
<br />指向创建内存转储文件的补充原语</p>
</td>
</tr>
<tr>
<td>
<br />rwlock_t</p>
</td>
<td>
<br />ioctx_list_lock</p>
</td>
<td>
<br />用于保护异步I/O上下文链表的锁</p>
</td>
</tr>
<tr>
<td>
<br />struct kioctx *</p>
</td>
<td>
<br />ioctx_list</p>
</td>
<td>
<br />异步I/O上下文链表</p>
</td>
</tr>
<tr>
<td>
<br />struct kioctx</p>
</td>
<td>
<br />default_kioctx</p>
</td>
<td>
<br />默认的异步I/O上下文</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />hiwater_rss</p>
</td>
<td>
<br />进程所拥有的最大页框数</p>
</td>
</tr>
<tr>
<td>
<br />unsigned long</p>
</td>
<td>
<br />hiwater_vm</p>
</td>
<td>
<br />进程线性区中的最大页数</p>
</td>
</tr>
</tbody>
</table>
<p>    所有的内存描述符存放在一个双向链表中。每个内存描述符在mmlist字段存放链表相邻元素的地址。链表的第一个元素是init_mm的mmlist字段，init_mm是初始化阶段进程0使用的内存描述符。</p>
<p>    注意理解和比较两个字段：mm_users和mm_count字段。</p>
<p>    # mm_users字段存放共享mm_struct数据结构的轻量级进程的个数。</p>
<p>    # mm_count字段是内存描述符的主使用计数器，在mm_users次使用计数器中的所有用户在mm_count中只作为一个单元。每当mm_count递减时，内核都要检查它是否变为0，如果是，就要解除这个内存描述符，因为不再有用户使用它。</p>
<p>===&gt;为什么要设置mm_count字段？见下文。</p>
<p>    内核线程的内存描述符</p>
<p>    内核线程就能运行在内核态，因此，它们永远不会访问低于TASK_SIZE(等于PAGE_OFFSET)的地址。与普通进程相反，内核线程不用线性区。因此描述符的很多字段对内核线程是没有意义的。</p>
<p>    内核线程使用前一个进程的内存描述符。</p>
<p>    在每个进程描述符中包含了两种内存描述符指针：mm和active_mm。</p>
<p>    进程描述符中的mm字段指向进程所拥有的内存描述符，而active_mm字段指向进程运行时所使用的内存描述符。对于普通进程，这两个字段存放相同的指针。但是，对于内核线程，由于内核线程不拥有任何内存描述符，因此，它们的mm字段总是NULL。当内核线程运行时，它的active_mm字段被初始化为前一个运行进程的active_mm值。</p>
<p>这里，可以解释上面mm_users字段和mm_count字段的区别：</p>
<p>&lt;&lt;&lt;====&gt;&gt;&gt;</p>
<p>    mm_users字段记录共享该内存描述符的普通进程的个数，mm_count的目的在于支持内核线程级别。</p>
<p>对Linux来说，用户进程和内核线程（kernel thread)都是task_struct的实例（tsk），唯一的区别是内核线程是没有进程地址空间的，内核线程也没有mm内存描述符，所以内核线程的tsk-&gt;mm域（其中，struct task_struct * tsk）是空（NULL）。当内核scheduler在执行进程上下文切换（context switching）时，会根据tsk-&gt;mm判断即将调度的进程是用户进程还是内核线程。虽然内核线程不访问用户进程地址空间，但是仍然需要通过page table来访问内核线程的内核地址空间。幸运的是，对于任何用户进程来说，它们的内核空间都是完全相同的（3G-4G），所以内核可以“借用”上一个被调用的用户进程的内存描述符mm中的页表来访问内核地址，并将此mm记录在active_mm。简而言之，对于用户进程，tsk-&gt;mm == tsk-&gt;active_mm；而对于内核线程，tsk-&gt;mm == NULL表示自己内核线程的身份，而tsk-&gt;active_mm是使用上一个用户进程的mm，通过此mm的page table来访问内核空间。</p>
<p>    为了支持内核线程级别，mm_struct里面引入了另外一个counter，主使用计数器mm_count。前面有mm_users表示这个进程地址空间被多少普通进程共享或者引用，而mm_count则表示这个地址空间被内核线程引用的次数+1（这里的1,指的是在mm_users次使用计数器中的所有用户在mm_count中只作为一个单元）。内核不会因为mm_users == 0而销毁此mm_struct，内核只会当mm_count == 0时才会释放mm_struct，因为这个时候既没有用户进程使用这个地址空间，也没有内核线程引用这个地址空间。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 23:28:04</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux内核剖析 之 进程地址空间（一）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZnjOb.html" rel="bookmark">Linux内核剖析 之 进程地址空间（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要讲述缺页异常处理程序和堆的管理等内容. 缺页异常处理程序 触发缺页异常程序的两种情况: 1. 由编程错误引起的异常(如访问越界,地址不属于进程地址空间). 2. 地址属于线性地址空间,但内核还未分配相应的物理页,导致缺页异常. 缺页异常处理程序总体方案: 线性区描述符可以让缺页异常处理程序非常有效的完成它的工作. do_page_fault()函数是80x86上的缺页中断服务程序,它把引起缺页的线性地址和当前进程的线性区相比较,从而根据具体方案选择适当的方法处理此异常. 标识符vmall			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4anPz.html" rel="bookmark">Linux内核剖析 之 进程地址空间（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				//接前一章,本节主要介绍线性区以及相关线性区的操作. 线性区 Linux通过类型为vm_area_struct的对象实现线性区. vm_area_struct: struct vm_area_struct { struct mm_struct * vm_mm; /* The address space we belong to. */ unsigned long vm_start; /* Our start address within vm_mm. */ unsigned long vm_e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE64Q3M.html" rel="bookmark">Linux内核剖析 之 进程简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.概念    1.1  什么是进程?     进程是程序执行的一个实例,可以看作充分描述程序已经执行到何种程度的数据结构的汇集.     从内核观点看,进程的目的就是担当分配系统资源(CPU时间,内存等)的实体.     我们熟悉的fork()库函数,它有两种用法:     (1).一个父进程希望复制自己,使父子进程执行不同的代码段,常用于网络服务程序.     (2).一个进程要执行一个不同的程序,fork()后立即exec(),如shell. 1.2  什么是线程?     有时候,一个进			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjjR2nb.html" rel="bookmark">linux内核分析之进程地址空间【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/bullbat/article/details/7106094 版权声明:本文为博主原创文章,未经博主允许不得转载. 本文主要介绍linux内核中进程地址空间的数据结构描述,包括mm_struct/vm_area_struct.进程线性地址区间的分配流程,并对相应的源代码做了注释.  内核中的函数以相当直接了当的方式获得动态内存.当给用户态进程分配内存时,情况完全不同了.进程对动态内存的请求被认为是不紧迫的,一般来说,内核总是尽量推迟给用户态进程分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVweVDb.html" rel="bookmark">Linux内核剖析 之 历史和体系结构分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux 内核剖析 之 历史和体系结构分析       Linux 内核是一个庞大而复杂的操作系统的核心,不过尽管庞大,但是却采用子系统和分层的概念很好地进行了组织.在本文中,您将探索 Linux 内核的总体结构,并学习一些主要的子系统和核心接口.您还可以通过其他 IBM 文章的链接更深入地进行学习.       由于本文的目标是对 Linux 内核进行介绍并探索其体系结构和主要组件,因此首先回顾一下 Linux 的简短历史,然后从较高的层次审视 Linux 内核的体系结构,最后介绍它的主要子			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvreB8M.html" rel="bookmark">Linux内核剖析 之 Linux源代码组成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux内核剖析 之 Linux源代码组成   ++++Linux:           ++COPYING:有关公共许可证制度GPL的具体说明.           ++README:Linux内核安装和使用的简要说明.           ++Makefile:重构Linux内核可执行代码的make文件.用来组织内核的各模块,记录了个模块间的联系和依托关系,编译时使用:仔细阅读各子目录下的Makefile文件对弄清各个文件这间的联系和依托关系很有帮助.           ++CREDIT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4g1Az.html" rel="bookmark">深入理解linux内核之&lpar;二&rpar;进程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				                                      深入理解linux内核之(二)进程       程序是静态的,进程是正在执行的程序的一个实例,一个程序可以由多个进程组成.进程是资源分配的实体.在进程被创建出来之后,该子进程几乎和父进程一样.子进程复制了父进程的地址空间,从fork()之后的第一条指令开始执行,和父进程有同样的程序可执行代码(exec调用除外).尽管子进程和父进程具有同样的程序执行代码,但是子进程拥有自己的stack和heap,因此,子进程对数据的修改对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4NE3LM.html" rel="bookmark">为arm内核构建源码树----Linux内核剖析（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面说到要做linux底层开发或者编写Linux的驱动,必须建立内核源码树,之前我们提到过在本机上构建源码树--Linux内核剖析(三),其建立的源码树是针对i686平台的,但是我么嵌入式系统用的是arm平台,这就需要我们为arm板交叉构建一份板子可用的内核源码树. 首先下载与你嵌入式系统平台版本号一致的linux内核,我的版本为2.6.35,当然如果你使用的是之前做好的板子,那么内核源码可能已经有了 我们解压缩我们的内核源码,并进入到内核源码的根目录 tar -jxvf linux-2.6.3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd61Emb.html" rel="bookmark">Linux系统调用详解（实现机制分析）--linux内核剖析（六）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系统调用概述 计算机系统的各种硬件资源是有限的,在现代多任务操作系统上同时运行的多个进程都需要访问这些资源,为了更好的管理这些资源进程是不允许直接操作的,所有对这些资源的访问都必须有操作系统控制.也就是说操作系统是使用这些资源的唯一入口,而这个入口就是操作系统提供的系统调用(System Call).在linux中系统调用是用户空间访问内核的唯一手段,除异常和陷入外,他们是内核唯一的合法入口. 一般情况下应用程序通过应用编程接口API,而不是直接通过系统调用来编程.在Unix世界,最流行的API			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNj1WM.html" rel="bookmark" class="title">Win7任务栏锁定功能应用</a>
					<div>
						个性化程度高.主界面美观是Win7系统的两大优点,也是Win7能让人们更加轻松享受科技生活的证明.Win7系统下任务栏就完美的继承了这 两大优势,我们通过简单的设置便能够在工作和娱乐中享受任务栏所带来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9x24b.html" rel="bookmark" class="title">浅谈遗留代码的重构</a>
					<div>
						             背景 &lt;重构&gt;诞生至今有近17个年头了,日常开发中大家谈到重构,要么非常随意,认为重构就是改代码:要么非常谨慎,把重构描述成焦油坑,像瘟神一样敬而远之.针对最具挑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP1W0z.html" rel="bookmark" class="title">移动设计优化&colon;让APP变得更快的设计方法</a>
					<div>
						文章描述:我们都知道不管网页还是移动应用,响应速度都是最重要的体验指标之一,并且移动应用的网络环境不稳定,速度的体验显得尤为重要.其实速度优化不仅是程序员的事,设计,也能够让App变得更快. D.A: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGK5Ez.html" rel="bookmark" class="title">Eclipse快速上手Hibernate--5&period; 组件映射</a>
					<div>
						    这篇文章主要说的是在Hibernate中的组件(Component)映射,可以参考Hibernate官方文档的第7章.至于环境设置,可以参考这个系列的前面几篇文章.  1. 创建项目 ·  新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3D40M.html" rel="bookmark" class="title">结合中国移动新举措，探讨站长成功新起点！</a>
					<div>
						站长 [引题一]:互联网不愧为一个英雄辈出,变幻莫测的大舞台.当初简单到没有人愿意做的网址站,没想到卖到那么高的价钱,令人垂涎.这个例子几乎成了站长发家的经典案例:当初纯粹是因为兴趣而做的软件下载站点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6oBYp.html" rel="bookmark" class="title">网站分析&colon;用户访问、内容浏览和流量来源</a>
					<div>
						我们在使用一些网站分析工具的时候会发现一般报表会被分成三大模块:用户访问.内容浏览和流量来源.每个分类都由各种分析度量组成了各类的展示报表,这里先介绍一下内容浏览模块(主要指的是网站的页面浏览)下的各 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b35awp.html" rel="bookmark" class="title">聊天室php&amp;amp&semi;mysql&lpar;五&rpar;</a>
					<div>
						第五个页面name=&quot;changenick.php&quot; &lt;?   include &quot;../signup/mysql.php&quot;; //echo $userid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB82Np.html" rel="bookmark" class="title">DataGrid合併行</a>
					<div>
						datagrid Private Sub UnitDataGridItem(ByVal intCell As Integer) Dim objDataGridItem As DataGridItem  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4vVwp.html" rel="bookmark" class="title">Photoshop如何打造淡淡的青黄韩系照片</a>
					<div>
						教程介绍淡淡韩系图片调色方法.大致过程:简单的美化图片后,用调色工具把图片整体颜色调亮,并加上基色,然后再局部调整,并增加高光及补色即可.         三联推荐:photoshop7.0迷你版免费 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa3KxM.html" rel="bookmark" class="title">win7蓝牙怎么打开？</a>
					<div>
						  win7怎么打开蓝牙? 1.点开控制面板--网络和共享中心,再点击&quot;更改适配器设置&quot;,如图; win7 win7怎么打开蓝牙步骤2.出现了蓝牙图标,看见没:打着叉号呢!不慌,右 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8lX1p.html" rel="bookmark" class="title">5步为相片加添暗角效果</a>
					<div>
						  无论是风景相片.婚摄pre-wedding.人像.动物等等的题材,加上暗角效果可以为相片加添不少气氛,当然最主要的是可以令读者视觉更集中于相片中间位置,突显主体,那么在Photoshop可以怎样快 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6X9db.html" rel="bookmark" class="title">电脑屏幕时不时的震动原因和解决参考</a>
					<div>
						这是一台笔记本电脑,而笔记本电脑的屏幕却时不时发现屏幕发现震动的情况. 电脑屏幕发现震动原因: 当出现电脑屏幕震动,无外乎以下几种原因,所以只需要进行一个个的原因去排除即可. 显卡驱动程序原因; 电脑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4294LM.html" rel="bookmark" class="title">C&plus;&plus;11中的智能指针</a>
					<div>
						在C++11中,引入了智能指针.主要有:unique_ptr, shared_ptr, weak_ptr. 这3种指针组件就是采用了boost里的智能指针方案.很多有用过boost智能指针的朋友,很容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZvOqz.html" rel="bookmark" class="title">笔记记录软件：NoteRecorder</a>
					<div>
						    利用SQLite数据库做了个笔记记录软件,加上搜索功能,方便自己记录东西所用.下载地址   (请在安装了.net framework 3.0/3.5的机器上运行,win7默认已安装该运行时)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2456kp.html" rel="bookmark" class="title">最受欢迎的5款Node&period;js端到端测试框架</a>
					<div>
						笔者在本文中会结合自身实践和 GitHub 趋势对比最受欢迎的 Node.js E2E 测试解决方案,期望对大家的技术选型有帮助 测试,尤其是自动化测试在现代 WEB 工程中有着非常重要的角色,与交付 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV9mZb.html" rel="bookmark" class="title">office-运行oneNote提示未安装桌面体验功能，跪求解答！！！</a>
					<div>
						问题描述 运行oneNote提示未安装桌面体验功能,跪求解答!!! 先说说环境:win7 旗舰版,microsoft offic 2010. 之前是装过一次(所有功能正常),但是中间一段时间没用过,最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7jxAz.html" rel="bookmark" class="title">Spark性能优化&mdash;&mdash;和shuffle搏斗</a>
					<div>
						Spark的性能分析和调优很有意思,今天再写一篇.主要话题是shuffle,当然也牵涉一些其他代码上的小把戏. 以前写过一篇文章,比较了几种不同场景的性能优化,包括portal的性能优化,web se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5N3Enz.html" rel="bookmark" class="title">哪位大哥大姐能给我一份JQuery中treeview绑定右键菜单</a>
					<div>
						问题描述 哪位大哥大姐能给我一份JQuery中treeview绑定右键菜单 treeview是读取数据库的,在treeview任一节点上单击右键弹出菜单(我自己设置的内容:例如:&quot;添加&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAjvqp.html" rel="bookmark" class="title">C&num;windows窗体显示问题</a>
					<div>
						问题描述 我是先做了一个子窗口之后再做了一个登入界面,以便点击登入界面的登入按钮后可以登入到那个子窗口,但是运行了才发现,直接显示的是那个子窗口.要怎么办才能在运行后显示登入界面呢???? 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBBN0M.html" rel="bookmark" class="title">这两个老外在天猫开了一家&OpenCurlyDoubleQuote;开门&rdquo;店</a>
					<div>
						老约翰(Johan Wikander)和小约翰(Johan Aledal)都是瑞典人,都叫约翰,但年龄相差悬殊,姓氏也不同.不过,他们有一家共同的公司Johan&amp;Johan,和一个共同的&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgvBYb.html" rel="bookmark" class="title">ActivityNet Challenge 2017 冠军方案分享</a>
					<div>
						任务介绍 此前我写过 Temporal Action Detection(时序行为检测)介绍一文介绍过 temporal action localization 方向(也可以叫做temporal ac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1jRkz.html" rel="bookmark" class="title">《Android应用开发攻略》&mdash;&mdash;第2章 设计成功的应用程序 2&period;1 导言：设计成功的Android应用程序</a>
					<div>
						第2章 设计成功的应用程序 2.1 导言:设计成功的Android应用程序 Colin Wilcox 讨论 本章介绍编写富于想象力而且实用的Android应用的设计指导思想.有几个攻略描述了成功设计的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBWmOz.html" rel="bookmark" class="title">编码-python2&period;7&period;5以ucs4编译</a>
					<div>
						问题描述 python2.7.5以ucs4编译 为什么用这些命令编译安装的还是ucs-2编码方式呢? ./configure --prefix=/usr/local/python27 --enable ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgonkM.html" rel="bookmark" class="title">老徐教你SEO之首页链接优化</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   在做SEO的时候,首页的优化是重中之重,而首页的链接是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXVPQb.html" rel="bookmark" class="title">TiDB 2016 回顾与 2017 的一些想法</a>
					<div>
						新年伊始,突然发现 TiDB 又一次被国际友人顶上了 HackerNews 首页前十,借着这个由头有友人约稿说想让我写一下对于这个数据库的过去和未来的一些想法和规划,正好这个周末偷得半日闲,于是赶紧动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWENGM.html" rel="bookmark" class="title">脸萌，虚拟世界集体变脸，未来网络&OpenCurlyDoubleQuote;证件照&rdquo;？</a>
					<div>
						[核心提示] &quot;漫画的出现将夸大人体意象引向了终极状态&quot;一样,谁又能否认,未来我们不会定制一款适合自己的漫画形象参加每周一的公司例会呢? 刚入六月,微信被脸萌刷爆,一个个萌萌哒:刚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwNAOM.html" rel="bookmark" class="title">哪些域名才是真正意义上的好域名？</a>
					<div>
						首先域名是互联网的门牌号,一个好的域名,就像是有一个好地段的房产权一样,一个好域名也是你的网站成功的基石.但是如何才能识别出哪些是好域名?下面先和大家谈谈什么类型的域名才是好域名. 1..COM是&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqx9Vb.html" rel="bookmark" class="title">挪威电信运营商Telenor拟瑞典裁员400人</a>
					<div>
						北京时间6月4日晚间消息,据国外媒体报道,挪威电信运营商Telenor瑞典业务部门周三宣布,由于业务疲软,将裁减400个工作岗位. Telenor瑞典业务部门掌门拉斯-阿克·诺林(Lars-?ke N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmGRmz.html" rel="bookmark" class="title">夫妇发短信谎称出售手机窃听器骗钱</a>
					<div>
						本报讯 记者王普,通讯员施立群.李澧.龚宣报道:10月1日国庆节当天,广州警方擒获一对通过发布销售手机窃听器材虚假短信息而实施诈骗的夫妇胡某某.曾某某. 今年8月底,有人以&quot;××安防科技有限 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr28WvM.html" rel="bookmark" class="title">mysql cluster 配置问题（Linux系统）</a>
					<div>
						问题描述 mysql cluster 配置问题(Linux系统) 1C http://blog.csdn.net/chengfei112233/article/details/7700559按照上面的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
